/*
 * x7.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2015-2019  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

static gboolean hide_widget_asynchronous (gpointer widget)
{
  gtk_widget_hide (widget);

  return FALSE;
}

int main (int argc, char **argv)
{
  Player player;
  HRESULT hr;
  int c;

  hr=CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);

  if (FAILED(hr)) {
    DVMESSAGE("CoInitializeEx() failed with 0x%p",hr);
    goto ecoinit;
  }

  if (PlayerCreate(&player,NULL)<0) {
    DMESSAGE("creating player");
    goto ewasapi;
  }

  for (;;) {
    c=fgetc(stdin);

    switch (c) {
    case 'x':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      goto end;
    case '+':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      GtkClientShow(&player.gtk,&player.gtk.about,NULL);
      break;
    case '-':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      g_idle_add (hide_widget_asynchronous, player.gtk.about.window);
      break;
    case '*':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      GtkClientShow(&player.gtk,&player.gtk.config,NULL);
      break;
    case '/':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      g_idle_add (hide_widget_asynchronous, player.gtk.config.window);
      break;
    default:
      break;
    }
  }
end:
  PlayerDestroy(&player);
ewasapi:
  CoUninitialize();
ecoinit:
  return 0;
}
