/*
 * yasapi_engine_volume.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2015-2019  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

///////////////////////////////////////////////////////////////////////////////
#define YASAPI_ID_DITHER(id) \
  YASAPI_PASTE3(RingDither,YASAPI_ID,id)
#define YASAPI_ID_IDITHER_VTBL(id) \
  YASAPI_PASTE3(gcIRingDither,id,Vtbl)

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_ID) // [
#undef YASAPI_ID
#endif // ]
#define YASAPI_ID Null

static void YASAPI_ID_DITHER(Start)(Ring *pRing)
{
}

static sample_t YASAPI_ID_DITHER(Noise)(Ring *pRing, WORD nChannel)
{
  return 0;
}

IRingDitherVtbl YASAPI_ID_IDITHER_VTBL(YASAPI_ID)={
  .pId=YASAPI_STRA(YASAPI_ID),
  .Start=YASAPI_ID_DITHER(Start),
  .Noise=YASAPI_ID_DITHER(Noise),
};

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_ID) // [
#undef YASAPI_ID
#endif // ]
#define YASAPI_ID Round

static void YASAPI_ID_DITHER(Start)(Ring *pRing)
{
  WORD wBitsPerSampleTarget=pRing->pClient->wfx.target.Format.wBitsPerSample;
  WORD wBitsPerSampleDither=((sizeof (sample_t))<<3)-wBitsPerSampleTarget;

  pRing->dither.round.noise=(~0ul)<<(wBitsPerSampleDither>>1);
}

static sample_t YASAPI_ID_DITHER(Noise)(Ring *pRing, WORD nChannel)
{
  return pRing->dither.round.noise;
}

IRingDitherVtbl YASAPI_ID_IDITHER_VTBL(YASAPI_ID)={
  .pId=YASAPI_STRA(YASAPI_ID),
  .Start=YASAPI_ID_DITHER(Start),
  .Noise=YASAPI_ID_DITHER(Noise),
};

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_ID) // [
#undef YASAPI_ID
#endif // ]
#define YASAPI_ID Simple

static void YASAPI_ID_DITHER(Start)(Ring *pRing)
{
  WORD wBitsPerSampleTarget=pRing->pClient->wfx.target.Format.wBitsPerSample;
  WORD wBitsPerSampleDither;

  if (((sizeof (sample_t))<<3)<wBitsPerSampleTarget) {
    DVMESSAGE("%d < %d",(sizeof (sample_t))<<3,wBitsPerSampleTarget);
    goto error;
  }

  wBitsPerSampleDither=((sizeof (sample_t))<<3)-wBitsPerSampleTarget;
  pRing->dither.simple.dwScaleNoise=1ul+RAND_MAX/wBitsPerSampleDither;
  return;
error:
  pRing->dither.simple.dwScaleNoise=UINT32_MAX;
  return;
}

static sample_t YASAPI_ID_DITHER(Noise)(Ring *pRing, WORD nChannel)
{
  if (0u==nChannel)
    pRing->dither.simple.noise=rand()/pRing->dither.simple.dwScaleNoise;

  return pRing->dither.simple.noise;
}

IRingDitherVtbl YASAPI_ID_IDITHER_VTBL(YASAPI_ID)={
  .pId=YASAPI_STRA(YASAPI_ID),
  .Start=YASAPI_ID_DITHER(Start),
  .Noise=YASAPI_ID_DITHER(Noise),
};
